//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.AuthorizationProvider
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Verify command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class VerifyRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _accessToken;
        
        private Tecan.Sila2.StringDto _requestedServer;
        
        private Tecan.Sila2.StringDto _requestedFeature;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public VerifyRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="accessToken">The token to be used along with accessing a Command or Property on a SiLA Server.</param>
        /// <param name="requestedServer">The server for which an authorization is requested.</param>
        /// <param name="requestedFeature">The feature that is requested to access.</param>
        public VerifyRequestDto(string accessToken, string requestedServer, string requestedFeature, Tecan.Sila2.IBinaryStore store)
        {
            AccessToken = new Tecan.Sila2.StringDto(accessToken, store);
            RequestedServer = new Tecan.Sila2.StringDto(requestedServer, store);
            RequestedFeature = new Tecan.Sila2.StringDto(requestedFeature, store);
        }
        
        /// <summary>
        /// The token to be used along with accessing a Command or Property on a SiLA Server.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto AccessToken
        {
            get
            {
                return _accessToken;
            }
            set
            {
                _accessToken = value;
            }
        }
        
        /// <summary>
        /// The server for which an authorization is requested.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto RequestedServer
        {
            get
            {
                return _requestedServer;
            }
            set
            {
                _requestedServer = value;
            }
        }
        
        /// <summary>
        /// The feature that is requested to access.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(3)]
        public Tecan.Sila2.StringDto RequestedFeature
        {
            get
            {
                return _requestedFeature;
            }
            set
            {
                _requestedFeature = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/AuthorizationProviderService/v1/Command/Verify";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(AccessToken, "accessToken");
            Argument.Validate(RequestedServer, "requestedServer");
            if ((RequestedServer.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("RequestedServer has length {0} but should have been 36", RequestedServer.Value.Length), "requestedServer");
            }
            if ((RegexConstraint.IsMatch(RequestedServer.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("RequestedServer \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{" +
                            "4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", RequestedServer.Value), "requestedServer");
            }
            Argument.Validate(RequestedFeature, "requestedFeature");
            if ((IdentifierConstraint.IsValid(RequestedFeature.Value, Tecan.Sila2.IdentifierType.FeatureIdentifier) == false))
            {
                throw new ArgumentException(string.Format("RequestedFeature \'{0}\' is not a valid FeatureIdentifier", RequestedFeature.Value), "requestedFeature");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ((("" + Argument.Require(AccessToken, "accessToken")) 
                        + Argument.Require(RequestedServer, "requestedServer")) 
                        + Argument.Require(RequestedFeature, "requestedFeature"));
            if ((RequestedServer.Value.Length != 36))
            {
                errors = (errors + string.Format("RequestedServer has length {0} but should have been 36", RequestedServer.Value.Length));
            }
            if ((RegexConstraint.IsMatch(RequestedServer.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("RequestedServer \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{" +
                        "4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}\'", RequestedServer.Value));
            }
            if ((IdentifierConstraint.IsValid(RequestedFeature.Value, Tecan.Sila2.IdentifierType.FeatureIdentifier) == false))
            {
                errors = (errors + string.Format("RequestedFeature \'{0}\' is not a valid FeatureIdentifier", RequestedFeature.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Verify command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class VerifyResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.IntegerDto _tokenLifetime;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public VerifyResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="tokenLifetime">The lifetime of the provided access token as the maximum validity period after the last SiLA Server request.</param>
        public VerifyResponseDto(long tokenLifetime, Tecan.Sila2.IBinaryStore store)
        {
            TokenLifetime = new Tecan.Sila2.IntegerDto(tokenLifetime, store);
        }
        
        /// <summary>
        /// The lifetime of the provided access token as the maximum validity period after the last SiLA Server request.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto TokenLifetime
        {
            get
            {
                return _tokenLifetime;
            }
            set
            {
                _tokenLifetime = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(TokenLifetime, "tokenLifetime");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(TokenLifetime, "tokenLifetime"));
        }
    }
}
